{
Author:  Prof1983: <prof1983@yandex.ru>
Created: 28.05.2011
LastMod: 28.05.2011
}
unit TestUnit6;

interface

uses
  Windows,
  TestCallData, TestUnit4;

function TestObjectCdecl: Integer;
function TestObjectFastcall: Integer;
function TestObjectSafecall: Integer;
function TestObjectStdcall: Integer;

implementation

function TestObjectCdecl: Integer;
var
  I: Integer;
  O: TObject1_1;
  T1: DWORD;
  T2: DWORD;
begin
  T1 := GetTickCount();
  O := TObject1_1.Create();
  for I := 0 to COUNT_I do
    O.Func(1, 2);
  //O := nil;
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestObjectFastcall: Integer;
var
  I: Integer;
  O: TObject0_1;
  T1: DWORD;
  T2: DWORD;
begin
  T1 := GetTickCount();
  O := TObject0_1.Create();
  for I := 0 to COUNT_I do
    O.Func(1, 2);
  //O := nil;
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestObjectSafecall: Integer;
var
  I: Integer;
  O: TObject3_1;
  T1: DWORD;
  T2: DWORD;
begin
  T1 := GetTickCount();
  O := TObject3_1.Create();
  for I := 0 to COUNT_I do
    O.Func(1, 2);
  //O := nil;
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestObjectStdcall: Integer;
var
  I: Integer;
  O: TObject2_1;
  T1: DWORD;
  T2: DWORD;
begin
  T1 := GetTickCount();
  O := TObject2_1.Create();
  for I := 0 to COUNT_I do
    O.Func(1, 2);
  //O := nil;
  T2 := GetTickCount();
  Result := T2 - T1;
end;

end.
 