{
Author:  Prof1983: <prof1983@yandex.ru>
Created: 27.05.2011
LastMod: 27.05.2011
}
unit TestUnit2;

interface

function ProcLongCdecl(Param1, Param2: Integer): Integer; cdecl;
function ProcLongFastcall(Param1, Param2: Integer): Integer;
function ProcLongSafecall(Param1, Param2: Integer): Integer; safecall;
function ProcLongStdcall(Param1, Param2: Integer): Integer; stdcall;

type
  TProc = function(Param1, Param2: Integer): Integer;
type
  PProcs = ^TProcs;
  TProcs = record
    Proc: TProc;
  end;

var
  Procs: PProcs;
  _Procs: TProcs;

implementation

function ProcLongCdecl(Param1, Param2: Integer): Integer; cdecl;
begin
  if Assigned(Procs) then
    Result := Procs^.Proc(Param1, Param2)
  else
    Result := 0;
end;

function ProcLongFastcall(Param1, Param2: Integer): Integer;
begin
  if Assigned(Procs) then
    Result := Procs^.Proc(Param1, Param2)
  else
    Result := 0;
end;

function ProcLongSafecall(Param1, Param2: Integer): Integer; safecall;
begin
  if Assigned(Procs) then
    Result := Procs^.Proc(Param1, Param2)
  else
    Result := 0;
end;

function ProcLongStdcall(Param1, Param2: Integer): Integer; stdcall;
begin
  if Assigned(Procs) then
    Result := Procs^.Proc(Param1, Param2)
  else
    Result := 0;
end;

end.
 