{
Author:  Prof1983 <prof1983@yandex.ru>
Created: 22.01.2009
LastMod: 29.05.2011
}
unit Unit1;

{
ProcShortFastcall      1640
ProcShortCdecl         2313
ProcShortStdcall       2297
ProcShortSafecall      4203

ProcLongFastcall       1953
ProcLongCdecl          3156
ProcLongStdcall        3453
ProcLongSafecall       4453

InterfaceFastcall      1703
InterfaceCdecl         2438
InterfaceStdcall       2390
InterfaceSafecall      3781
InterfaceDispatch      3797
}

{WARN SYMBOL_PLATFORM OFF}
{TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers.
{WRITEABLECONST ON}
{VARPROPSETTER ON}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComObj, ComServ, Buttons,
  TestCallData, TestProcLong, TestProcShort, TestUnit1, TestUnit2, TestUnit5, TestUnit6;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button4: TButton;
    Label4: TLabel;
    Button5: TButton;
    Label0: TLabel;
    Label1_1: TLabel;
    Label2_1: TLabel;
    Label3_1: TLabel;
    Label0_1: TLabel;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button10: TButton;
    Memo1: TMemo;
    Label5: TLabel;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    Label7: TLabel;
    ShortFastcallLabel: TLabel;
    ShortCdeclLabel: TLabel;
    ShortStdcallLabel: TLabel;
    ShortSafecallLabel: TLabel;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    LongSafecallLabel: TLabel;
    LongStdcallLabel: TLabel;
    LongCdeclLabel: TLabel;
    LongFastcallLabel: TLabel;
    BitBtn2: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  protected
    procedure DoCreate; override;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Label1.Caption := IntToStr(TestInterfaceCdecl);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Label2.Caption := IntToStr(TestInterfaceStdcall);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Label3.Caption := IntToStr(TestInterfaceSafecall);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Label4.Caption := IntToStr(TestInterfaceDispatch);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Label0.Caption := IntToStr(TestInterfaceFastcall);
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  Label0_1.Caption := IntToStr(TestObjectFastcall);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Label1_1.Caption := IntToStr(TestObjectCdecl);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Label2_1.Caption := IntToStr(TestObjectStdcall);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  Label3_1.Caption := IntToStr(TestObjectSafecall);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  ProcShortFastcallTicks: Integer;
  I: Integer;
  S: string;
begin
  //           
  begin
    ProcShortFastcallTicks := TestProcShortFastcall;
    S := IntToStr(ProcShortFastcallTicks) + ' ticks = 100%';
    ShortFastcallLabel.Caption := S;
    Memo1.Lines.Add('First ' + S);
  end;

  //if CheckBox10.Checked then
  begin
    ProcShortFastcallTicks := TestProcShortFastcall;
    S := IntToStr(ProcShortFastcallTicks) + ' ticks = 100%';
    ShortFastcallLabel.Caption := S;
    Memo1.Lines.Add('TestProcShortFastcall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox11.Checked then
  begin
    I := TestProcShortCdecl;
    S := IntToStr(I) + ' tikcs = ' + IntToStr((I * 100) div ProcShortFastcallTicks) + '%';
    ShortCdeclLabel.Caption := S;
    Memo1.Lines.Add('TestProcShortCdecl ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox12.Checked then
  begin
    I := TestProcShortStdcall;
    S := IntToStr(I) + ' ticks = ' + IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    ShortStdcallLabel.Caption := S;
    Memo1.Lines.Add('TestProcShortStdcall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox13.Checked then
  begin
    I := TestProcShortSafecall;
    S := IntToStr(I) + ' ticks = ' + IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    ShortSafecallLabel.Caption := S;
    Memo1.Lines.Add('TestProcShortSafecall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;


  if CheckBox14.Checked then
  begin
    I := TestProcLongFastcall;
    S := IntToStr(I) + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    LongFastcallLabel.Caption := S;
    Memo1.Lines.Add('TestProcLongFastcall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox15.Checked then
  begin
    I := TestProcLongCdecl;
    S := IntToStr(I) + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    LongCdeclLabel.Caption := S;
    Memo1.Lines.Add('TestProcLongCdecl ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox16.Checked then
  begin
    I := TestProcLongStdcall;
    S := IntToStr(I) + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    LongStdcallLabel.Caption := S;
    Memo1.Lines.Add('TestProcLongStdcall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox17.Checked then
  begin
    I := TestProcLongSafecall;
    S := IntToStr(I) + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    LongSafecallLabel.Caption := S;
    Memo1.Lines.Add('TestProcLongSafecall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;


  if CheckBox1.Checked then
  begin
    I := TestInterfaceFastcall;
    S := IntToStr(I) + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    Label0.Caption := S;
    Memo1.Lines.Add('TestInterfaceFastcall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox2.Checked then
  begin
    I := TestInterfaceCdecl;
    S := IntToStr(I) + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    Label1.Caption := S;
    Memo1.Lines.Add('TestInterfaceCdecl ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox3.Checked then
  begin
    I := TestInterfaceStdcall;
    S := IntToStr(I);
    Label2.Caption := S + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    Memo1.Lines.Add('TestInterfaceStdcall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox4.Checked then
  begin
    I := TestInterfaceSafecall;
    S := IntToStr(I);
    Label3.Caption := S + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    Memo1.Lines.Add('TestInterfaceSafecall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox5.Checked then
  begin
    I := TestInterfaceDispatch;
    S := IntToStr(I);
    Label4.Caption := S + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    Memo1.Lines.Add('TestInterfaceDispatch ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;


  if CheckBox6.Checked then
  begin
    I := TestObjectFastcall;
    S := IntToStr(I) + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    Label0_1.Caption := S;
    Memo1.Lines.Add('TestObjectFastcall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox7.Checked then
  begin
    I := TestObjectCdecl;
    S := IntToStr(I) + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    Label1_1.Caption := S;
    Memo1.Lines.Add('TestObjectCdecl ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox8.Checked then
  begin
    I := TestObjectStdcall;
    S := IntToStr(I);
    Label2_1.Caption := S + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    Memo1.Lines.Add('TestObjectStdcall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  if CheckBox9.Checked then
  begin
    I := TestObjectSafecall;
    S := IntToStr(I);
    Label3_1.Caption := S + ' ticks = '+IntToStr((I*100) div ProcShortFastcallTicks) + '%';
    Memo1.Lines.Add('TestObjectSafecall ' + S);
  end;
  Application.ProcessMessages;
  if FStopping then Exit;

  {
  Memo1.Lines.Add('ProcPascal '+IntToStr(TestProcShortFastcall));
  Memo1.Lines.Add('ProcStdcall '+IntToStr(TestProcShortStdcall));
  Memo1.Lines.Add('ProcLongPascal '+IntToStr(TestProcLongFastcall));
  Memo1.Lines.Add('ProcLongStdcall '+IntToStr(TestProcLongStdcall));
  }
end;

procedure TForm1.DoCreate;
begin
  inherited;
  _Procs.Proc := ProcFastcall;
  Procs := Addr(_Procs);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  FStopping := True;
end;

end.
